<script lang="ts" setup>
import type { BaseLink, BaseCard } from '@/types/base';
import { ChevronLgRight, BullseyeArrow } from 'slippers-ui/icons';

interface ExtendedCard extends BaseCard {
  primaryButton?: BaseLink;
  subtitle?: string;
  content?: string[];
}

const icons = {
  BullseyeArrow,
};

defineProps({
  title: {
    type: String,
    required: false,
  },
  primaryButton: {
    type: Object as PropType<BaseLink>,
    required: true,
  },
  secondaryButton: {
    type: Object as PropType<BaseLink>,
    required: false,
  },
  cards: {
    type: Array as PropType<ExtendedCard[]>,
    required: true,
  },
  spotlight: {
    type: Object as PropType<ExtendedCard>,
    required: false,
  },
  config: {
    type: Object as PropType<{ icon: string }>,
    required: false,
  },
});
</script>

<template>
  <section class="service-cards">
    <SlpContainer>
      <div class="service-cards__icon-wrapper">
        <SlpIcon v-if="config?.icon" :icon="icons[config.icon]" class="service-cards__icon" />
      </div>
      <SlpTypography variant="heading2-bold" tag="h2" class="slp-mb-24"
        ><div v-html="$md.render(title)"
      /></SlpTypography>
      <SlpButton
        :href="primaryButton.config?.href"
        variant="primary"
        :data-ga-name="primaryButton.config?.dataGaName"
        :data-ga-location="primaryButton.config?.dataGaLocation"
        class="service-cards__card__button"
      >
        {{ primaryButton.text }}
      </SlpButton>
      <SlpButton
        v-if="secondaryButton"
        :href="secondaryButton.config?.href"
        variant="tertiary"
        :data-ga-name="secondaryButton.config?.dataGaName"
        :data-ga-location="secondaryButton.config?.dataGaLocation"
        class="slp-ml-16"
        >{{ secondaryButton.text }}<SlpIcon :icon="ChevronLgRight" class="learn-more__icon" alt="" />
      </SlpButton>
      <SlpRow class="slp-mt-48">
        <SlpColumn v-for="card in cards" :key="card.title" :cols="4" class="service-cards__column">
          <div class="service-cards__card">
            <div class="service-cards__card__content">
              <SlpTypography variant="heading5-bold" tag="h3">{{ card.title }}</SlpTypography>
            </div>
            <ul class="service-cards__card__list">
              <li v-for="item in card.content" :key="item">
                <SlpTypography variant="body2" tag="p" class="slp-mt-4">{{ item }}</SlpTypography>
              </li>
            </ul>
            <div class="service-cards__card__buttons">
              <SlpButton
                v-if="card.primaryButton"
                :href="card.primaryButton.config?.href"
                variant="tertiary"
                :data-ga-name="card.primaryButton.config?.dataGaName"
                :data-ga-location="card.primaryButton.config?.dataGaLocation"
                class="service-cards__card__button"
              >
                {{ card.primaryButton.text
                }}<SlpIcon :icon="ChevronLgRight" size="sm" alt="" class="service-cards__card__button__icon" />
              </SlpButton>
            </div>
          </div>
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
.service-cards {
  padding: $spacing-96 0;
  @media (max-width: $breakpoint-md) {
    padding: $spacing-64 0;
  }

  &__icon-wrapper {
    background-color: $color-surface-950;
    border-radius: 50%;
    padding: $spacing-4;
    height: 48px;
    width: 48px;
    display: flex;
    align-items: center;
    justify-content: center;
    margin-bottom: $spacing-24;
  }

  &__icon {
    height: 28px;
    width: 28px;
  }

  .slp-row {
    @media (max-width: $breakpoint-md) {
      width: 100%;
    }
  }

  &__column {
    display: flex;
    align-items: stretch;
    margin-bottom: $spacing-24;

    &:nth-child(3n + 1) {
      .service-cards__card {
        margin-right: $spacing-8;
        margin-left: 0;
        @media (max-width: $breakpoint-md) {
          margin-right: 0;
        }
      }
    }

    &:nth-child(3n) {
      .service-cards__card {
        margin-left: $spacing-8;
        margin-right: 0;
        @media (max-width: $breakpoint-md) {
          margin-left: 0;
        }
      }
    }

    &:nth-child(3n + 2) {
      .service-cards__card {
        margin: 0 $spacing-8;
        @media (max-width: $breakpoint-md) {
          margin: 0;
        }
      }
    }
  }

  &__card__button__icon.slp-icon {
    margin-left: $spacing-8;
  }

  &__card {
    display: flex;
    flex-direction: column;
    width: 100%;
    max-width: none;
    border: 1px solid $color-surface-300;
    border-radius: $spacing-8;

    &__content {
      padding: $spacing-32 $spacing-24;
      background-color: $color-surface-950;
      border-bottom: 1px solid $color-surface-300;
      flex: 0 0 auto;
      display: flex;
      flex-direction: column;
      justify-content: flex-start;
    }

    &__list {
      list-style: disc;
      padding: $spacing-24 $spacing-24 0 $spacing-24;
      margin: 0;
      flex: 1 0 auto;
      display: flex;
      flex-direction: column;
      min-height: 250px;
      background: $color-surface-50;

      :deep(li) {
        margin-bottom: $spacing-8;
        padding-left: $spacing-24;
        position: relative;
        list-style-type: none;
      }

      :deep(li:before) {
        content: url('../../public/images/backgrounds/check.svg');
        position: absolute;
        left: 0;
        top: 6px;
        width: 20px;
        height: 20px;
        z-index: 5;
      }
    }

    &__buttons {
      padding: $spacing-32 $spacing-24;
      width: 100%;
      display: flex;
      gap: $spacing-16;
      flex-direction: row;
      background-color: $color-surface-50;
      border-radius: 0 0 $spacing-8 $spacing-8;
      margin-top: auto;
      flex: 0 0 auto;
      min-height: 100px;
    }
  }
}
</style>
